<?php

/**
 * Description of JSON
 *
 * @author Andres
 */
class JSON {
    
    static protected $error = null;
    static private $lastAccess = null;
    static private $lastAccessSize = null;

    static private function setOpenError($filePath){
        self::$error = "No se pudo leer el archivo $filePath";
    }
    
    static private function setWriteError($filePath){
        self::$error = "No se pudo escribir el archivo $filePath";
    }

    static private function read($filePath){
        self::$error = null;
        $_fp = fopen($filePath, "r");
        
        if ($_fp !== FALSE){
            $fileSize = self::getFileSize($filePath);
            $ret = fread($_fp, $fileSize);
            if($ret === null){
                self::setOpenError($filePath);
            }else{
                fclose($_fp);
                self::setLastAccess($filePath,$fileSize);
            }
        }else{
            $ret = NULL;
            self::setOpenError($filePath);
        }
        
        return $ret;
    }
    
    static private function write($filePath,$json){
        self::$error = null;
        $_fp = fopen($filePath, "w");
        
        if ($_fp !== FALSE){
            $ret = fwrite($_fp, $json);
            if($ret === null){
                self::setWriteError($filePath);
            }else{
                fclose($_fp);
                self::setLastAccess($filePath, $ret);
            }
        }else{
            $ret == NULL;
            self::setOpenError($filePath);
        }
        return $ret;
    }
    
    static private function remove($fileName){
        self::$error = null;
        $ret = unlink($fileName);
        //TODO si se utiliza, chequear el error
        return $ret;
    }
    
    static private function getFileSize($filePath){
        $fileSize = filesize($filePath);
        if($filePath === self::$lastAccess && $fileSize < self::$lastAccessSize)
            $fileSize = self::$lastAccessSize;
        return $fileSize;
    }
    
    static private function setLastAccess($filePath,$fileSize){
        self::$lastAccess = $filePath;
        self::$lastAccessSize = $fileSize;
    }
    
    static function getError(){
        return self::$error;
    }
    
    static function open($filePath) {
        self::$error = null;
        $ret = false;
        
        if(is_file($filePath)){
            $json = self::read($filePath);
            $ret = json_decode($json);
            if($ret === NULL){
                self::$error = "Error al decodear Json.";
            }
            
        }else{
            self::setOpenError($filePath);
        }
        
        return $ret;
    }
    
    static function openFileArray($fileArray){
        self::$error = null;
        $ret = array();
        
        if(is_array($fileArray)){
            foreach ($fileArray as $name => &$urlFile) {
                if(is_file($urlFile)){
                    $json = self::read($urlFile);
                    $ret[$name] = json_decode($json);
                }
            }
        }else{
            $ret = false;
        }
        
        return $ret;
    }
    
    static function Update($filePath, &$object){
        self::$error = null;
        $ret = -1;
		
        if(is_file($filePath) && is_writable($filePath)){  
	    $json = json_encode($object);
            if($json !== null){
                $ret = self::write($filePath, $json);
            }else{
                self::$error = "Error al escribir el archivo $filePath.";
            }
        }else{
            self::setOpenError($filePath);
        }
        return $ret;
    }
    
    static function BeginTransaction(){
        
    }
    
    static function Commit(){
        
    }
    
    static function Rollback(){
        
    }
    
}
